#pragma once

#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <sys/time.h>
#include "Camera.h"
#include "MyFiles.h"
#include <vector>

#include "Graphics.h"


// Include GLM
#include "../glm/glm/glm.hpp"
#include "../glm/glm/gtc/matrix_transform.hpp"

#include "ObjectModel.h"


class Game
{
public:
	Game();
	~Game();
	
	Graphics* MyGraphics;  // create a 1 time instance of a graphics class;
		
	MyFiles	Handler;
	std::vector<ObjectModel*> MyObjects;
	
	
	Camera*	TheCamera;
	
	Camera* GetCamera()
	{
		return TheCamera;
	}
	
	uint32_t	ScreenX, ScreenY;


	bool	Init(Graphics* Graph);
	bool	Update();
	
		
};



