/* We still have a generic hello cubes entry function
 * this is C code, but it has the purpose of setting up the important
 * classes we need to play the game
*/

#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <sys/time.h>
#include "bcm_host.h"
#include <EGL/egl.h>
#include <EGL/eglext.h>
#include <GLES2/gl2.h>
#include <vector>
// Include GLM
#include "glm/glm/glm.hpp"
#include "glm/glm/gtc/matrix_transform.hpp"
#include "Headers/ShaderManager.h"
#include "Headers/tiny_obj_loader.h"


#include "Game.h"

using namespace glm;
using namespace std;

// our main function is now much simpler, it does not even need to have these here they could be in the Game Class

int main(int argc, char *argv[])
{

// the only thing we really don't want game to do is init the graphics, since its machine specific
// and easier to do here one time
	Graphics Graphics;  // create a 1 time instance of a graphics class;
	Graphics.esInitContext();
	Graphics.init_ogl(1024, 768); // set any size we want, but screen size is a good idea
	
// having set up Graphics, make an instance of the game, and go play.
	Game	TheGame;
	TheGame.Init(&Graphics); // we will let the game know where the graphics instance is, as we are still a bit dependant on it
	TheGame.Update();
}
