
#include "../Headers/Camera.h"

Camera::Camera()
{
	// Projection matrix : 45 Field of View, 4:3 ratio, display range : near 0.1 unit <->  far 100 units
	Projection = glm::perspective(45.0f, 4.0f / 3.0f, 0.1f, 100.0f);
	
	View  = glm::lookAt(
		glm::vec3(10, 10, 24), // Camera is at (17,23,3), in World Space
		glm::vec3(0, 0, 0), // look at the origin
		glm::vec3(0, 1, 0)  // pointing up( 0,-1,0 will be upside-down));
		);
}

Camera::~Camera()
{
	
}


glm::mat4* Camera::GetView()
{
	return &View;
}



glm::mat4* Camera::GetProjection()
{
	
	return &Projection;
}